# -*- coding: utf-8 -*-

"""
/***************************************************************************
 AddGridRef
                                 A QGIS plugin
 Adds British or Irish grid references to layers
 Generated by Plugin Builder: http://g-sherman.github.io/Qgis-Plugin-Builder/
                              -------------------
        begin                : 2019-01-30
        copyright            : (C) 2019 by Field Studies Council
        email                : r.burkmar@field-studies-council.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""

__author__ = 'Field Studies Council'
__date__ = '2019-01-30'
__copyright__ = '(C) 2019 by Field Studies Council'

# This will get replaced with a git SHA1 when you do a git archive

__revision__ = '$Format:%H$'

from qgis.core import QgsProcessingProvider
from qgis.core import QgsMessageLog
from qgis.core import Qgis
from .add_grid_ref_algorithm import AddGridRefAlgorithm


class AddGridRefProvider(QgsProcessingProvider):

    def __init__(self, iface):
        QgsProcessingProvider.__init__(self)

        # Load algorithms
        QgsMessageLog.logMessage("__init__ called", "Add GR Tool", Qgis.Info)

        #Call to AddGridRefAlgorithm moved to loadAlgorithms to fix issue #37
        #self.alglist = [AddGridRefAlgorithm()]

    def unload(self):
        """
        Unloads the provider. Any tear-down steps required by the provider
        should be implemented here.
        """
        QgsMessageLog.logMessage("unload called", "Add GR Tool", Qgis.Info)

    def loadAlgorithms(self):
        """
        Loads all algorithms belonging to this provider.
        """
        QgsMessageLog.logMessage("loadAlgorithms called", "Add GR Tool", Qgis.Info)

        #This function gets called if user changes default CRS in QGIS options (I don't know why)
        #and it fell over at the addAlgorithm call unless we first regenerate the alglist
        self.alglist = [AddGridRefAlgorithm()] #Fix for issue #37

        for alg in self.alglist:
            self.addAlgorithm( alg )

    def id(self):
        """
        Returns the unique provider id, used for identifying the provider. This
        string should be a unique, short, character only string, eg "qgis" or
        "gdal". This string should not be localised.
        """
        return 'FSC'

    def name(self):
        """
        Returns the provider name, which is used to describe the provider
        within the GUI.

        This string should be short (e.g. "Lastools") and localised.
        """
        return self.tr('FSC Tools')

    def longName(self):
        """
        Returns the a longer version of the provider name, which can include
        extra details such as version numbers. E.g. "Lastools LIDAR tools
        (version 2.2.1)". This string should be localised. The default
        implementation returns the same string as name().
        """
        return self.name()
